/***********************************************/
/* examples program for ET-LAB3A               */
/* description : read NTC & LDR                */
/* compilrer   : hi-tech c51                   */
/***********************************************/
#include <8051.h>
#include <stdio.h>

#define din    P0_BITS.B0
#define dout   P0_BITS.B4
#define clk    P0_BITS.B2
#define cs     P0_BITS.B3

#define E      P1_BITS.B2
#define RW     P1_BITS.B1
#define RS     P1_BITS.B0
 
char lcdbuf[16+1];

void init_lcd(void);
void gotolcd(unsigned char);
void write_ins(unsigned char);
void write_data(unsigned char);
void printlcd(void);
void delay(char);

unsigned char sigadc0(void);
unsigned char sigadc1(void);
void delspi(unsigned char);

void main(void)
{
  unsigned char i;
  
  delay(10);

  cs   = 1;
  clk  = 0;
  dout = 1;

  init_lcd(); 

  sprintf(lcdbuf,"NTC   LDR");
  printlcd();

  while(1)
  {
    i = sigadc0();
  
    gotolcd(0x40);
    sprintf(lcdbuf,"%02X",i);
    printlcd();

    i = sigadc1();
    gotolcd(0x46);
    sprintf(lcdbuf,"%02X",i);
    printlcd();
  }

 return;  
}

unsigned char sigadc0(void)
{
  unsigned char i;
  unsigned char j;
  
  cs = 0;

  din = 1;  
  clk = 1; delspi(5); 
  clk = 0; delspi(5); 
 
  din = 1;  
  clk = 1; delspi(5);    
  clk = 0; delspi(5); 
 
  din = 0;  
  clk = 1; delspi(5);    
  clk = 0; delspi(5);  

  for(j=0;j<8;j++)
  {
    clk = 1; delspi(5);
	clk = 0; delspi(5);
 
    i <<= 1; 
    if(dout == 1) {i |= 0x01;}
    else          {i &= 0xfe;}
  }
   
  cs = 1;
	
 return i;
}



unsigned char sigadc1(void)
{
  unsigned char i;
  unsigned char j;
  
  cs = 0;

  din = 1;  
  clk = 1; delspi(5); 
  clk = 0; delspi(5); 
 
  din = 1;  
  clk = 1; delspi(5);    
  clk = 0; delspi(5); 
 
  din = 1;  
  clk = 1; delspi(5);    
  clk = 0; delspi(5);  

  for(j=0;j<8;j++)
  {
    clk = 1; delspi(5);
	clk = 0; delspi(5);
 
    i <<= 1; 
    if(dout == 1) {i |= 0x01;}
    else          {i &= 0xfe;}
  }
   
  cs = 1;
	
 return i;
}


void printlcd(void)
{
 char *p;
 
 p = lcdbuf;
 
 do{
    write_data(*p); 
    p++;
 }while(*p != '\0');
 
 return;
}


void init_lcd(void)
{
  write_ins(0x33);
  write_ins(0x32);
  write_ins(0x28);
  write_ins(0x08);
  write_ins(0x01);
  write_ins(0x02);
  write_ins(0x0E);

 return;
}


void gotolcd(unsigned char i)
{
  i |= 0x80;

  write_ins(i); 
 
  return;
}


void write_ins(unsigned char i)
{
  
  P1 = i & 0xF0;
  E = 1;    delay(2);
  E = 0;    delay(2);

  P1 = (i << 4) & 0xF0;
  E = 1;   delay(2);
  E = 0;   delay(2);

 return;
}


void write_data(unsigned char i)
{
  
  P1 = (i & 0xF0) | 0x01;
  E = 1;    delay(2);
  E = 0;    delay(2);

  P1 = ((i << 4) & 0xF0) | 0x01;
  E = 1;    delay(2);
  E = 0;    delay(2);

 return;
}

void delay(char i)
{
  unsigned int j;

  do
  {
    for(j=0;j<500;j++) {}
	i--; 
  }while(i > 0);

return;
}


void delspi(unsigned char j)
{
  do{}while(j-- > 0);
}






